//
//  SelfiePreviewViewController.swift
//  Pods
//
//  Created by Juan Carlos Pérez on 1/30/19.
//  Copyright (c) 2019 ___ORGANIZATIONNAME___. All rights reserved.
//
//  This file was generated by the Clean Swift Xcode Templates so
//  you can apply clean architecture to your iOS and Mac projects,
//  see http://clean-swift.com
//

import UIKit

protocol SelfiePreviewDisplayLogic: class
{
  func displaySomething(viewModel: SelfiePreview.Something.ViewModel)
}

class SelfiePreviewViewController: UIViewController, SelfiePreviewDisplayLogic
{
    
    @IBOutlet weak var imvSelfiePreview: UIImageView!
    
    
    var imgPhoto : UIImage?//Foto
    
  var interactor: SelfiePreviewBusinessLogic?
  var router: (NSObjectProtocol & SelfiePreviewRoutingLogic & SelfiePreviewDataPassing)?

  // MARK: Object lifecycle
  
  override init(nibName nibNameOrNil: String?, bundle nibBundleOrNil: Bundle?)
  {
    super.init(nibName: nibNameOrNil, bundle: nibBundleOrNil)
    setup()
  }
  
  required init?(coder aDecoder: NSCoder)
  {
    super.init(coder: aDecoder)
    setup()
  }
  
  // MARK: Setup
  
  private func setup()
  {
    let viewController = self
    let interactor = SelfiePreviewInteractor()
    let presenter = SelfiePreviewPresenter()
    let router = SelfiePreviewRouter()
    viewController.interactor = interactor
    viewController.router = router
    interactor.presenter = presenter
    presenter.viewController = viewController
    router.viewController = viewController
    router.dataStore = interactor
  }
  
  // MARK: Routing
  
  override func prepare(for segue: UIStoryboardSegue, sender: Any?)
  {
    if let scene = segue.identifier {
      let selector = NSSelectorFromString("routeTo\(scene)WithSegue:")
      if let router = router, router.responds(to: selector) {
        router.perform(selector, with: segue)
      }
    }
  }
  
  // MARK: View lifecycle
  
  override func viewDidLoad()
  {
    super.viewDidLoad()
    doSomething()
  }
  
  // MARK: Do something
  
  //@IBOutlet weak var nameTextField: UITextField!
  
  func doSomething()
  {
    let request = SelfiePreview.Something.Request()
    interactor?.doSomething(request: request)
  }
  
  func displaySomething(viewModel: SelfiePreview.Something.ViewModel)
  {
    self.imgPhoto = viewModel.imgSelfie
    self.imvSelfiePreview.image = self.imgPhoto
  }
    
    
    @IBAction func btnContinue(_ sender: Any) {
        /*
        let newSize = CGSize(width: (self.imgPhoto?.size.width)! / 2, height: (self.imgPhoto?.size.height)! / 2)
        let newImage = self.imgPhoto?.resizeImage(targetSize: newSize)
        
        let dataNewImage = newImage!.jpegData(compressionQuality: 0.7)
        let newPNGImg = UIImage(data: dataNewImage!)
        */
        
        FADModulePhoto.initProcessOnSuccess!(self.imgPhoto!)
    }
    
    @IBAction func btnCancel(_ sender: Any) {
        router?.routeToInstructions(segue: nil)
    }
}
